package com.example.ipawidgetapp;

import java.util.ArrayList;
import java.util.Arrays;

import android.app.Activity;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.widget.RemoteViews;
import android.widget.RemoteViewsService.RemoteViewsFactory;

// RemoteViewsFactoryy is an interface for an adapter between a remote collection view (ListView, GridView, etc) and the underlying data for that view. 
public class AppWidgetViewsFactory implements RemoteViewsFactory {
	
//	All saved data will be stored in the SharedPreferences set defined below
	private SharedPreferences sharedSet;
	private SharedPreferences.Editor sharedSetEditor;
	
	private String url;
	private String username;
	private String password;
	private String[] checked;
	private String sharedChecked;
	
	private Context context = null;
	private ArrayList<String> arrayList = new ArrayList<String>();
	private String header;

	public AppWidgetViewsFactory(Context context, Intent intent) {
		this.context = context;
		sharedSet = context.getSharedPreferences("Set", Activity.MODE_PRIVATE);
		sharedSetEditor = sharedSet.edit();
	}
	
	@Override
	public void onCreate() {
		// TODO Auto-generated method stub
		arrayList.add("Test");
	}

	@Override
	public void onDataSetChanged() {
		if (!Custom_Methods.isWifiOn(context)) {
			url = sharedSet.getString("url", "");
			username = sharedSet.getString("username", "");
			password = sharedSet.getString("password", "");
			sharedChecked = sharedSet.getString("checked", "");
			checked = sharedChecked.split(","); // the array with the last checked Headertitles we need
			String[][] responsetable = Custom_Methods.to2dim(Custom_Methods.getHTTPResponse(url, username, password), "\\r?\\n", "\\=");
			arrayList.clear();
			// Now only using the desired headers:
			// 2DIM ARRAY ITERATOR
	        for (int table = 0; table < responsetable.length -1; table++) { // -1 because we don't want the ending line (the timestamp) as a selectable header because it is variable
	        	for (int element = 0; element < responsetable[table].length; element++) {
	        		// Only the title has to get selected
	        		if (element == 0) {
	            		// Checking if this header was selected before
		        		if (Arrays.asList(checked).contains('"' + responsetable[table][element] + '"')) {
		        			if (responsetable[table][element +1] == null) {
		        				// If there's no value to this headertitle, just put the headertitle itself
		        				header = responsetable[table][element];
		        			} else {
		        				header = responsetable[table][element] + "=" + responsetable[table][element +1];
		        			}
			        		arrayList.add(header);
		        		}
	        		}
	        	}
	        }
		} else {
			arrayList.clear();
			arrayList.add("WLAN Interface is active, please disable it first.");
		}
	}

	@Override
	public void onDestroy() {
		// TODO Auto-generated method stub
		// nothing to do
	}

	@Override
	public int getCount() {
		// TODO Auto-generated method stub
		return arrayList.size();
	}

	@Override
	public RemoteViews getViewAt(int position) {
		RemoteViews listview_text1 = new RemoteViews(context.getPackageName(), R.layout.lsv_headers);
		listview_text1.setTextViewText(android.R.id.text1, arrayList.get(position));
		return listview_text1;
	}

	@Override
	public RemoteViews getLoadingView() {
		// TODO Auto-generated method stub
		return null;
	}

	@Override
	public int getViewTypeCount() {
		// TODO Auto-generated method stub
		return 1;
	}

	@Override
	public long getItemId(int position) {
		// TODO Auto-generated method stub
		return position;
	}

	@Override
	public boolean hasStableIds() {
		// TODO Auto-generated method stub
		return true;
	}
	
}
