package com.example.ipawidgetapp;

import java.io.BufferedReader;
import java.io.InputStream;
import java.io.InputStreamReader;

import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.impl.client.DefaultHttpClient;

import android.content.Context;
import android.net.wifi.WifiManager;
import android.util.Base64;
import android.util.Log;

public class Custom_Methods {
	
	// Gets the response from the given url in HTML plaintext and removes all tags
	public static String getHTTPResponse(String url, String username, String password) {
		String response = "";
        DefaultHttpClient client = new DefaultHttpClient();
        String credentials = username + ":" + password;
        HttpGet httpGet = new HttpGet(url);
        String base64EncodedCredentials = Base64.encodeToString(credentials.getBytes(), Base64.NO_WRAP);  
        httpGet.addHeader("Authorization", "Basic " + base64EncodedCredentials);
        try {
            HttpResponse execute = client.execute(httpGet);
            InputStream content = execute.getEntity().getContent();

            BufferedReader buffer = new BufferedReader(new InputStreamReader(content));
            String s = "";
            while ((s = buffer.readLine()) != null) {
                response += s;
                Log.v("HTTP Response", response); // Just logging if the HTTP response is working
            }
            // Time to junk this HTTP repsonse down to how we want it!
            response = response.trim().replaceAll(" +", " "); // Remove multiple spaces and make them single spaces, so we don't get trouble later on for linebreaking
            response = response.replaceAll("<(.*?)\\>", " "); // Remove all HTML tags
            response = response.replaceAll("<(.*?)\\\n", " "); // Kills the ending tag
            response = response.replaceFirst("(.*?)\\>", " "); //Removes any connected item to the last bracket
            response = response.replaceAll("&nbsp;", " "); // Replace all non-breaking spaces with a regular space
            response = response.replaceAll("&amp;", " "); // Replace all ampersands with spaces (optional)
            response = response.trim().replaceAll("\\s{2,}", "\r\n"); // If there's now a gap with 2+ spaces, we'll replace it with a linebreak
            Log.v("Final", response); // And here we see if the output is how we want it
            
        } catch (Exception e) {
            e.printStackTrace();
        }
        return response;
	}
	
	// Checks if the given url and logindata equals the HTTP response code 200
	public static Boolean HTTPAccess(String url, String username, String password) {
		DefaultHttpClient client = new DefaultHttpClient();
        String credentials = username + ":" + password;
        HttpGet httpGet = new HttpGet(url);
        String base64EncodedCredentials = Base64.encodeToString(credentials.getBytes(), Base64.NO_WRAP);  
        httpGet.addHeader("Authorization", "Basic " + base64EncodedCredentials);
        try {
            HttpResponse execute = client.execute(httpGet);
            if (execute.getStatusLine().getStatusCode() == 200) {
            	return true;
            } else {
            	return false;
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        return false;
	}

	// Below function puts a string into a two-dimensional array
	public static String [][] to2dim (String source, String outerdelim, String innerdelim) {
	    String [] sOuter = source.split (outerdelim); 
	    int size = sOuter.length;
	    // one dimension of the array has to be known on declaration:
	    String [][] result = new String [size][]; 
	    int count = 0;
	    for (String line : sOuter)
	    {
	        result [count] = line.split (innerdelim, -1); // "-1" causes to also use "empty" splits
	        ++count;
	    }
	    return result;
	}
	
	public static boolean isWifiOn(Context context) {
	     WifiManager wifi = (WifiManager) context.getSystemService(Context.WIFI_SERVICE);
	     return wifi.isWifiEnabled();
	}
}
