package com.example.ipawidgetapp;

import java.util.ArrayList;

import com.example.ipawidgetapp.R;

import android.app.Activity;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.CheckBox;

// Adapter that is required to build the CheckBoxes that are being populated into the ListView (Select Headertitle)
public class HeaderAdapter extends ArrayAdapter<Headers>{
	
	private ArrayList<Headers> modelheaders;
	private Context context;

	public HeaderAdapter(Context context, int textviewResourceId, ArrayList<Headers> resource) {
		super(context, textviewResourceId, resource);
		// TODO Auto-generated constructor stub
		this.context = context;
		this.modelheaders = resource;
	}

	private class ViewHolder {
		CheckBox cb;
	}

	@Override
	public View getView(int position, View convertView, ViewGroup parent) {

		ViewHolder holder = null;
		// TODO Auto-generated method stub
		if (convertView == null) {
			// A LayoutInflater sort of creates a virtual View given by a .xml file so the attributes of the View can be handled
			LayoutInflater inflater = ((Activity)context).getLayoutInflater();
			convertView = inflater.inflate(R.layout.lsv_headerselection, parent, false);
			holder = new ViewHolder();
			holder.cb = (CheckBox) convertView.findViewById(R.id.checkBox1);
			convertView.setTag(holder);

			holder.cb.setOnClickListener(new View.OnClickListener() {

				// this way it also works when clicking on the CheckBox' name and not just the square
				
				@Override
				public void onClick(View v) {
					
					// TODO Auto-generated method stub
					CheckBox cb = (CheckBox) v ;  
				    Headers header = (Headers) cb.getTag();
				    header.setSelected(cb.isChecked());
				}
			});
		}
		else {
			holder = (ViewHolder) convertView.getTag();
		}
		
		Headers header = modelheaders.get(position);
		holder.cb.setText(header.getName());
		holder.cb.setChecked(header.isSelected());
		holder.cb.setTag(header);
		
		return convertView;
	}
}
