package com.example.ipawidgetapp;

import java.util.HashMap;
import java.util.Map;

import android.app.Activity;
import android.content.SharedPreferences;
import android.os.Bundle;
import android.util.Base64;
import android.webkit.WebView;
import android.widget.Toast;

// Activity for showing the desired website in the WebView
public class ShowWebsite extends Activity {

//	All saved data will be stored in the SharedPreferences set defined below
	private SharedPreferences sharedSet;

	@Override
	protected void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		WebView webview = new WebView(this);
		setContentView(webview);
		if (Custom_Methods.isWifiOn(this)) {
			Toast.makeText(getApplicationContext(), "WARNING: WLAN Interface active!", Toast.LENGTH_LONG).show();
		}
		sharedSet = getSharedPreferences("Set", Activity.MODE_PRIVATE);
		String credentials = sharedSet.getString("username", "") + ":" + sharedSet.getString("password", "");
        String base64EncodedCredentials = Base64.encodeToString(credentials.getBytes(), Base64.NO_WRAP);  
        Map<String, String> headers = new HashMap<String, String>();
        headers.put("Authorization", "Basic " + base64EncodedCredentials);
		webview.loadUrl(sharedSet.getString("url", ""), headers);
	}
}
