package com.example.ipawidgetapp;

import android.app.Activity;
import android.app.PendingIntent;
import android.appwidget.AppWidgetManager;
import android.appwidget.AppWidgetProvider;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.SharedPreferences;
import android.os.StrictMode;
import android.util.Log;
import android.widget.RemoteViews;

import com.example.ipawidgetapp.R;

public class WidgetProvider extends AppWidgetProvider {
	
//	All saved data will be stored in the SharedPreferences set defined below
	private static SharedPreferences sharedSet;

	public void onUpdate(Context context, AppWidgetManager appWidgetManager, int[] appWidgetIds) {
		StrictMode.ThreadPolicy policy = new StrictMode.ThreadPolicy.Builder().permitAll().build();
        StrictMode.setThreadPolicy(policy);
        sharedSet = context.getSharedPreferences("Set", Activity.MODE_PRIVATE);
        Intent listviewIntent = new Intent(context, WidgetService.class);
		RemoteViews views = new RemoteViews(context.getPackageName(), R.layout.widgetproviderlayout);
		views.setOnClickPendingIntent(R.id.touchable_layout, ShowWebsite(context));
		views.setOnClickPendingIntent(R.id.btnWebsite, ShowWebsite(context));
		views.setOnClickPendingIntent(R.id.btnRefresh, RefreshWidget(context));
		views.setOnClickPendingIntent(R.id.btnConfig, ConfigMask(context));
		views.setRemoteAdapter(R.id.lsvHeaders, listviewIntent);
		Log.v("OnUpdate", "OnUpdate was just executed");
		pushWidgetUpdate(context, views);
	}
	public static PendingIntent ShowWebsite(Context context) {
		Intent intent = new Intent(context, ShowWebsite.class);
		return PendingIntent.getActivity(context, 0, intent, 0);
	}
	public static PendingIntent RefreshWidget(Context context) {
		Intent intent = new Intent();
		intent.setAction("intent_action.REFRESH_WIDGET");
		return PendingIntent.getBroadcast(context, 0, intent, PendingIntent.FLAG_UPDATE_CURRENT);
	}
	public static PendingIntent ConfigMask(Context context) {
		Intent intent = new Intent(context, ConfigMask.class);
		return PendingIntent.getActivity(context, 0, intent, 0);
	}
	public static void pushWidgetUpdate(Context context, RemoteViews remoteViews) {
		ComponentName myWidget = new ComponentName(context, WidgetProvider.class);
	    AppWidgetManager manager = AppWidgetManager.getInstance(context);
	    manager.updateAppWidget(myWidget, remoteViews);		
	}
}
